function varargout = ReductionEditor(varargin)
% REDUCTIONEDITOR MATLAB code for ReductionEditor.fig
%      REDUCTIONEDITOR, by itself, creates a new REDUCTIONEDITOR or raises the existing
%      singleton*.
%
%      H = REDUCTIONEDITOR returns the handle to a new REDUCTIONEDITOR or the handle to
%      the existing singleton*.
%
%      REDUCTIONEDITOR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in REDUCTIONEDITOR.M with the given input arguments.
%
%      REDUCTIONEDITOR('Property','Value',...) creates a new REDUCTIONEDITOR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ReductionEditor_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ReductionEditor_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ReductionEditor

% Last Modified by GUIDE v2.5 11-Sep-2019 18:18:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ReductionEditor_OpeningFcn, ...
                   'gui_OutputFcn',  @ReductionEditor_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ReductionEditor is made visible.
function ReductionEditor_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ReductionEditor (see VARARGIN)

% Choose default command line output for ReductionEditor
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%Reaction Table Load
global table_index;
global tab_v;
table_index = 1;
tab_v = strings(10,3);
tab_v = cellstr(tab_v);
display("tabla varargin");
display(varargin{1});
if(isempty(varargin{1}))
    display("Warning: empty table");    
else
    tab_v = varargin{1};
end

%Save data
guidata(hObject,handles);

%Variables and Constants separation
[handles.x handles.kfwd handles.f] = getDynamicModel(tab_v);
handles.x_values = cell(length(handles.x),1);
handles.c_values = cell(length(handles.kfwd),1);
%TABLE1: VARIABLES VALUES
%Print table after openingFn
set(handles.uitable1, 'Data', cellstr(string(handles.x)));
num_reacs = {'1'};
%Create rows as reactions
for i=1:length(handles.x);
    num_reacs{i} = int2str(i);
end
set(handles.uitable1, 'RowName', num_reacs, 'ColumnName', {'Variable','Value'});


%TABLE2: CONSTANTS VALUES
%Print table after openingFn
set(handles.uitable2, 'Data', cellstr(string(handles.kfwd)));
num_reacs = {'1'};
%Create rows as reactions
for i=1:length(handles.kfwd);
    num_reacs{i} = int2str(i);
end
set(handles.uitable2, 'RowName', num_reacs, 'ColumnName', {'Constant','Value'});

%TABLE3: DYNAMIC MODEL
set(handles.uitable3, 'Data', cellstr(string([handles.x handles.f])));
num_reacs = {'1'};
%Create rows as reactions
for i=1:length(handles.x);
    num_reacs{i} = int2str(i);
end
set(handles.uitable3, 'RowName', num_reacs, 'ColumnName', {'Variability','Function'});
%column width
col_max = {};
aux = 0;
for i=1:length(handles.x)
    for j=1:2
        if i==1
            aux = 75;
        else
            aux = 250;
        end
    end
    col_max = [col_max aux];
end
set(handles.uitable3,'ColumnWidth', col_max)

%Save data
guidata(hObject,handles);

% UIWAIT makes ReductionEditor wait for user response (see UIRESUME)
% uiwait(handles.figure1);
uiwait

% --- Outputs from this function are returned to the command line.
function varargout = ReductionEditor_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1
contents = cellstr(get(hObject,'String'));
handles.T = contents{get(hObject,'Value')};
handles.T
t_cell = split(handles.T);
m = zeros(length(t_cell),length(handles.x));
for i=1:length(t_cell)
    m((i),str2num(t_cell{i})) = 1;
end
display("output matrix");
m
handles.C = m;

%Visualize output matrix C
c = string(m);
d = "";
for i=1:size(c,1)
    if i==1
        if size(c,1)==1
            d = horzcat(d,'[',c(i,:),']');
        else
            d = horzcat(d,'[',c(i,:),';');%first row     
        end
    elseif i==size(c,1)
        d = horzcat(d,c(size(c,1),:),']');%last row
    else
        d = horzcat(d,c(i,:),';');
    end
end
aux="";
for i=1:(length(d))
    aux = strcat(aux,(d(i) +" "));
end
set(handles.edit1,'String',aux);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'String','1 2');
guidata(hObject,handles);


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.listSet = {};
handles.listSet = cellstr(get(handles.listbox1,'String'));
handles.listSet = vertcat(handles.listSet,handles.addSet);
set(handles.listbox1,'String',string(handles.listSet));
guidata(hObject,handles);


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
handles.C = str2num(get(hObject,'String'));
handles.C
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% % %%%%%TEST%%%%
% % %Species
% % syms mt ml pt pl
% % 
% % %Unknown constants
% % syms K K bt bl dt dl betaT betaL deltaT deltaL
% % f =[(K*bt)/(bt + pl) - dt*mt;
% %  (K*bl)/(bl + pt) - dl*ml;
% %      betaT*mt - deltaT*pt;
% %      betaL*ml - deltaL*pl];
% % 
% % x =[ mt; ml; pt; pl];
% % 
% % % %Output matrix
% % C = [ 0 0 1 0;
% %       0 0 0 1];
% % %%%%%%%%%%%%%
%handles.fred = reductionAlgorithm('3 4',f,x,C,0,0);
[handles.fred handles.xred] = reductionAlgorithm(handles.T,handles.f,handles.x,handles.C,0,0);

[handles.f1 handles.f2 handles.f3] = getSensibility(handles.xred,handles.f,handles.fred,handles.kfwd);

o = SensibilityOutput(handles.f1,handles.f2,handles.f3,handles.xred);
f = msgbox(string(handles.fred),'Reduced Model Functions');
guidata(hObject,handles);


function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double
handles.addSet = cellstr(get(hObject,'String'));
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)

handles.x_values{eventdata.Indices(1)} = (eventdata.EditData);
handles.x_values
cellstr(string(handles.x))
set(handles.uitable1, 'Data', [cellstr(string(handles.x)) handles.x_values]);
guidata(hObject,handles);


% --- Executes when entered data in editable cell(s) in uitable2.
function uitable2_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable2 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)


handles.c_values{eventdata.Indices(1)} = (eventdata.EditData);
handles.c_values
cellstr(string(handles.kfwd))
set(handles.uitable2, 'Data', [cellstr(string(handles.kfwd)) handles.c_values]);
guidata(hObject,handles);


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
