%%%% Algorithm Reduction Function %%%%

function [output1 output2] = reductionAlgorithm(T,f,x,C,tolE,tolSe)
%Loading bar
fbar=waitbar(0.1,"Reducing...");

%% Variables declaration
fcol = {}; %collapsed variables function vector
fred = {}; %reduced model funtion vector
xcol = {}; %collapsed variables vector
xred = {}; %reduced variables vector
% T = [];    %set of possible reduced model variables
% Se = [];
R = str2num(T);
R = {R};
%R = num2cell(R,length(R))



%Indexes
col_index = 1;
red_index = 1;

%Jacobian matrix
 J = [diff(f(1),x(1)) diff(f(1),x(2)) diff(f(1),x(3)) diff(f(1),x(4));
      diff(f(2),x(1)) diff(f(2),x(2)) diff(f(2),x(3)) diff(f(2),x(4));
      diff(f(3),x(1)) diff(f(3),x(2)) diff(f(3),x(3)) diff(f(3),x(4));
      diff(f(4),x(1)) diff(f(4),x(2)) diff(f(4),x(3)) diff(f(4),x(4))];

  
% % %% Model
% % %Species
% % syms mt ml pt pl
% % 
% % %Unknown constants
% % syms K K bt bl dt dl betaT betaL deltaT deltaL
% % 
% % %R list example
% % R = {[1 3 4],...
% %      [2 3 4],...
% %      [3 4]};
% % %TEST %
% % R = {[4]};
% % 
% % %Function vector
% % f = [(K*bt/(bt + pl)) - dt*mt;
% %      (K*bl/(bl + pt)) - dl*ml;
% %       betaT*mt - deltaT*pt;
% %       betaL*ml - deltaL*pl];
% %   
% % %Species vector
% % x = [mt; ml; pt; pl];
% % 
% % %Dynamic output matrix
% % C = zeros(length(R{1}),length(x));
% % for i=1:length(R{1})
% %     C(i,R{1}(i)) = 1;
% % end


  %% Algorithm
for j = 1:length(R)
    %Set up collapsed and reduces for each possible reduced model
    T = R{j};
    for i = 1:length(x)
        if ismember(i,T)==1
            xcol{col_index} = x(i);
            fcol{col_index} = f(i);
            col_index = col_index + 1;
        else    
            xred{red_index} = x(i);
            fred{red_index} = f(i);
            red_index = red_index + 1;
        end
        waitbar(0.2+(i/length(i))*0.4,fbar);
    end
end
    
% % %% Solve system equations
% % 
% % %Get R complement
% % complementR = 0;
% % complement_index = 1;
% % for i=1:length(x)
% %     if(ismember(i,R{1})==0)
% %         complementR(complement_index) = i;
% %         complement_index = complement_index + 1;
% %     end
% % end
% % %complementR = num2cell(complementR,length(complementR));
% % 
% % %Set equations
% % eqns = [];
% % vars = [];
% % complementR
% % for i=1:length(complementR)
% %     eqns = [eqns f(complementR(i))==0];
% %     vars = [vars x(complementR(i))];
% % end
% % 
% % waitbar(0.7,fbar);
% % 
% % %Solve and substitute 
% % %WARNING: NOT WORKING FOR (LENGTH(SYSTEM)-1) EQUATIONS
% % sol = solve(eqns,vars);
% % waitbar(0.9,fbar);
% % sol = struct2cell(sol)
% % sol{1}
% % sol{2}
% % sol{3}
% % sol{4}
% % fsol = {};
% % eqns
% % vars
% % for k=1:length(R{1})
% %     for h=1:length(vars)
% %         if (has(f(R{1}(k)),vars(h))==1)
% %             fsol{k} = subs(f(R{1}(k)),vars(h),sol{h})
% %         end
% %     end
% % end    
% % waitbar(0.99,fbar);

    %Solve ODEs for x and xred, compute y and yred    
    
    %Get Error Sensibility from equation    
    %DO NOT FORGET SQUARE ROOT OF ERROR SENSIBILITY 
        
% % %     %Jacobian matrix for solution [{3 4}]
% % %     Jred = [diff(fred{1},xcol{1}) diff(fred{1},xcol{2});
% % %             diff(fred{2},xcol{1}) diff(fred{2},xcol{2})];
% % %         
% % %     %Augmented Jacobian matrix construction
% % %     zeromat1 = zeros(size(J,1),size(Jred,2));
% % %     zeromat2 = zeros(size(Jred,1),size(J,2));
% % %     Jaug = [J        zeromat1; 
% % %             zeromat2 Jred   ];
% % %     Caug = [C              zeros(size(C))
% % %             zeros(size(C)) C           ];
% % %     Q = transpose(Caug) * Caug;
% % %     P = lyap(transpose(Jaug),Q)
    


    %Solve reduced functions for each variable
    fsol={};
    sol_index = 1;
    for k = 1:length(xred)       
      eqn = fred{k} == 0;
      sol = solve(eqn,xred{k});
      for h=1:length(xcol)
         if has(fcol{h},xred{k})==1
             fsol{sol_index} = subs(fcol{h},xred{k},sol);
             sol_index = sol_index + 1;
         end
      end
      waitbar(0.6 + (k/length(xred))*0.3,fbar);
    end
    
    %Display solution
    out = {};
    isrepeated = 0;
    outindex = 1;
    for i=1:length(fsol)
        if fsol{i} ~=0
            if length(out)>0
                for j=1:length(out)
                    if out{j} == fsol{i}
                        isrepeated = 1;
                    end
                end
                if isrepeated == 0
                    out{outindex} = fsol{i};
                    outindex = outindex + 1;
                end
            else
                out{outindex} = fsol{i};
                outindex = outindex + 1;
            end
        end
    end
    waitbar(0.9,fbar);
    display("solucion de reducion: ");
    for i=1:length(out)
        out{i}
    end
    delete(fbar);
    output1 = out;
    output2 = xcol;

